package jhdz.difusion.data.data.login;

import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;

import jhdz.cultural.R;
import jhdz.difusion.constantes.URL_API;
import jhdz.difusion.data.menu_activity.Menu_Activity;

/**
 * Created by core on 06/03/18.
 */

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.graphics.Color;
import android.support.constraint.ConstraintLayout;
import android.support.design.widget.Snackbar;
import android.text.method.LinkMovementMethod;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;


import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RegistroActivity  extends AppCompatActivity  {

    private static final String TAG = RegistroActivity.class.getSimpleName();
    private static final int DATE_DIALOG_ID = 1;

    private int year;
    private int month;
    private int day;
    private String currentDate;
    EditText correo, pass,re_pass;
    EditText nombre, apellido;

    TextView link;
    Button f_na, enviar_datos;

    private ProgressDialog pDialog;


    String FEC = "";
    ConstraintLayout ct;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_perfil);
        final Calendar c = Calendar.getInstance();
        year = c.get(Calendar.YEAR);
        month = c.get(Calendar.MONTH);
        day = c.get(Calendar.DAY_OF_MONTH);

        pDialog = new ProgressDialog(this);
        pDialog.setMessage("Espera...");
        pDialog.setCancelable(false);

        correo = (EditText) findViewById(R.id.textemail);
        pass = (EditText) findViewById(R.id.textpass);
        re_pass = (EditText) findViewById(R.id.textpass_);
        nombre = (EditText) findViewById(R.id.textnom);
        apellido = (EditText) findViewById(R.id.txtapellido);
        enviar_datos =(Button)findViewById(R.id.enviar);
        ct =(ConstraintLayout)findViewById(R.id.ct);
        link=(TextView)findViewById(R.id.link_);

        f_na = (Button) findViewById(R.id.date);

        enviar_datos = (Button) findViewById(R.id.enviar);

        link.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String url = "http://variablecrud.com/cultural/php/politicas.php#";
                Intent i = new Intent(Intent.ACTION_VIEW);
                i.setData(Uri.parse(url));
                startActivity(i);
            }
        });

        f_na.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                final Calendar c = Calendar.getInstance();
                year = c.get(Calendar.YEAR);
                month = c.get(Calendar.MONTH);
                day = c.get(Calendar.DAY_OF_MONTH);
                showDialog(DATE_DIALOG_ID);
            }
        });


        enviar_datos.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {


                if (Form() == true) {

                    showpDialog();
                    Peticion_Servicio();

                            }


                if (Form() == false) {
                    hidepDialog();
                }


            }
        });

    }

    private boolean Form() {
        String PATTERN_EMAIL = "^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*@"
                + "[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$";
        Pattern pattern = Pattern.compile(PATTERN_EMAIL);

        Matcher matcher = pattern.matcher(correo.getText().toString());
         if (nombre.getText().toString().equals("")) {
            nombre.setHintTextColor(Color.RED);
            nombre.setHint("Complete este campo");
            hidepDialog();
            return false;
        }
        if (apellido.getText().toString().equals("")) {
            apellido.setHintTextColor(Color.RED);
            apellido.setHint("Completa este campo");
            hidepDialog();
            return false;
        }
        if (correo.getText().toString().equals("") ) {

            correo.setHintTextColor(Color.RED);
            correo.setHint("Complete este campo correctamente.");
            hidepDialog();
            return false;

        }
        if(!matcher.find()){
            hidepDialog();
            correo.setHint("Complete este campo correctamente.");
            return false;
        }
        if (pass.getText().toString().equals("")) {
            pass.setHintTextColor(Color.RED);
            pass.setHint("Completa este campo.");
            hidepDialog();
            return false;
        }
        if(re_pass.getText().toString().equals("")){
            re_pass.setHintTextColor(Color.RED);
            re_pass.setHint("Completa este campo.");
            hidepDialog();
            return false;
        }
        if(!pass.getText().toString().matches(re_pass.getText().toString())){
            hidepDialog();
            re_pass.setTextColor(Color.RED);
            re_pass.setText("Completa este campo.");
            Snackbar.make(f_na, " Ambas contraseñas debe coincidir.", Snackbar.LENGTH_LONG).show();
            return false;
        }

        if (FEC.isEmpty()) {
            hidepDialog();
            Snackbar.make(f_na, " Inserte fecha de nacimiento.", Snackbar.LENGTH_LONG).show();
            return false;
        }

        return true;
    }

    private void updateDisplay() {

        currentDate = new StringBuilder().append(year).append("-")
                .append(month + 1).append("-").append(day).toString();
        Log.i("DATE", currentDate);
    }




    DatePickerDialog.OnDateSetListener myDateSetListener = new DatePickerDialog.OnDateSetListener() {

        @Override
        public void onDateSet(DatePicker datePicker, int i, int j, int k) {

            year = i;
            month = j;
            day = k;
            updateDisplay();
            FEC = currentDate;
            f_na.setText(currentDate);
            FEC = f_na.getText().toString();
        }
    };


    @Override
    protected Dialog onCreateDialog(int id) {
        switch (id) {
            case DATE_DIALOG_ID:
                return new DatePickerDialog(this, myDateSetListener, year, month,
                        day);
        }
        return null;
    }

    @Override
    public void onBackPressed() {
        hidepDialog();
        Intent activity = new Intent(this, LoginActivity.class);
        startActivity(activity);
        finish();

    }

    private void showpDialog() {
        if (!pDialog.isShowing())
            pDialog.show();
    }

    private void hidepDialog() {
        if (pDialog.isShowing())
            pDialog.dismiss();
    }

    public void Peticion_Servicio() {

        StringRequest stringRequest = new StringRequest(Request.Method.POST, URL_API.REGISTRO,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {



                        Pattern pat = Pattern.compile(".*error.*");
                        Matcher mat = pat.matcher(response);




                        if (mat.find()) {

                            hidepDialog();
                            Toast.makeText(getApplicationContext()," Ya hay un registro con esa direción de correo.",Toast.LENGTH_LONG).show();

                        } else {

                            hidepDialog();
                            Session session = new Session(getApplicationContext());
                            session.createLoginSession(correo.getText().toString());

                            Intent activity = new Intent(getApplicationContext(), Menu_Activity.class);

                            startActivity(activity);
                            finish();

                        }


                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {

                        hidepDialog();
                        Snackbar.make(ct, " Algo salio mal, intentalo mas tarde . " , Snackbar.LENGTH_LONG).show();


                    }
                }) {
            @Override
            protected Map<String, String> getParams() {
                Map<String, String> params = new HashMap<String, String>();

                params.put("correo",  correo.getText().toString());
                params.put("contrasena", pass.getText().toString());
                params.put("nombre", nombre.getText().toString());
                params.put("apellido", apellido.getText().toString());
                params.put("fecha", FEC);

                return params;
            }

        };

        RequestQueue requestQueue = Volley.newRequestQueue(this);
        requestQueue.add(stringRequest);


    }



}
