package jhdz.difusion.data.cultural;

import android.app.ProgressDialog;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;

import java.util.HashMap;
import java.util.Map;

import jhdz.cultural.R;
import jhdz.difusion.constantes.URL_API;

public class DetailsActivity extends AppCompatActivity {

    EditText correo;
    Button enviar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.detailsactivity);

        correo=(EditText)findViewById(R.id.correo_enviar);
        enviar=(Button) findViewById(R.id.button_enviar);
        correo.setHint("Correo");




            enviar.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {

                    final ProgressDialog progressDialog = new ProgressDialog(DetailsActivity.this,
                            ProgressDialog.STYLE_HORIZONTAL);
                    progressDialog.setIndeterminate(true);
                    progressDialog.setCancelable(false);
                    progressDialog.show();

                    new Handler().postDelayed(new Runnable(){
                        public void run(){

                        if(Validar()==false) {

                        }

                        if(Validar()==true) {
                            Verificar_correo();
                            progressDialog.dismiss();
                        }

                        progressDialog.dismiss();


                        correo.setEnabled(false);
                        enviar.setEnabled(false);






                            };
                        }, 1000);
                    }




            });




    }
    public void Verificar_correo(){


        StringRequest stringRequest = new StringRequest(Request.Method.POST, URL_API.RECUPERARACCESO,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {

                            Toast.makeText(getApplicationContext(),""+response,Toast.LENGTH_LONG).show();

                    }
                },
                new Response.ErrorListener() {
                    @Override
                    public void onErrorResponse(VolleyError error) {
                        Log.d("",error.toString());
                        Toast.makeText(getApplicationContext(),""+error.toString(),Toast.LENGTH_LONG).show();

                    }
                }) {
            @Override
            protected Map<String, String> getParams() {
                Map<String, String> params = new HashMap<String, String>();
                params.put("correo", correo.getText().toString());

                return params;
            }

        };

        RequestQueue requestQueue = Volley.newRequestQueue(DetailsActivity.this);
        requestQueue.add(stringRequest);
    }
    public boolean Validar (){
        String  email = correo.getText().toString();


        if(email.isEmpty()|| !android.util.Patterns.EMAIL_ADDRESS.matcher(email).matches()) {
            correo.setError("Completa el campo correspondiente");
            enviar.setEnabled(true);

            return false;
        }
        return true;
    }

    @Override
    public void onBackPressed() {

        finish();

    }

}
