package jhdz.difusion.data.menu_activity;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;


import android.support.v7.widget.CardView;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;

import jhdz.cultural.R;
import jhdz.difusion.data.avisos.Avisos;
import jhdz.difusion.data.data.login.Session;
import jhdz.difusion.data.evento.Categoria;
import jhdz.difusion.data.perfil.Perfil;

public class Menu_Activity extends AppCompatActivity  implements View.OnClickListener{


CardView perfil,eventos,avisos;

    Session session;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_menu_);

        session = new Session(getApplicationContext());
        perfil =(CardView)findViewById(R.id.cardView_a);
        eventos =(CardView)findViewById(R.id.cardView_b);
        avisos =(CardView)findViewById(R.id.cardView_c);


        perfil.setOnClickListener(this);
        eventos.setOnClickListener(this);
        avisos.setOnClickListener(this);

    }

    @Override
    public void onClick(View view) {

         switch (view.getId()){
            case R.id.cardView_a:
                startActivity(new Intent(getApplicationContext(),Perfil.class));
                break;
            case R.id.cardView_b:
                startActivity(new Intent(getApplicationContext(),Categoria.class));
                break;
            case R.id.cardView_c:
                startActivity(new Intent(getApplicationContext(),Avisos.class));
                break;
        }
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu_principal, menu);
        return true;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.menu_itam:

                    session.logoutUser();

                return true;

            default:
                return super.onOptionsItemSelected(item);
        }
    }
    @Override
    public void onBackPressed() {

        finish();

    }
}
