-- phpMyAdmin SQL Dump
-- version 4.8.0.1
-- https://www.phpmyadmin.net/
--
-- Servidor: localhost:3306
-- Tiempo de generación: 28-05-2018 a las 21:21:11
-- Versión del servidor: 10.2.15-MariaDB
-- Versión de PHP: 7.0.30

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET AUTOCOMMIT = 0;
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Base de datos: `u462066862_app`
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `categoria_evento`
--

CREATE TABLE `categoria_evento` (
  `categoria_id` int(5) NOT NULL,
  `categoria_nombre` varchar(50) CHARACTER SET utf8 NOT NULL,
  `categoria_descripcion` varchar(100) CHARACTER SET utf8 NOT NULL,
  `categoria_img` varchar(100) CHARACTER SET utf8 NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `categoria_evento`
--

INSERT INTO `categoria_evento` (`categoria_id`, `categoria_nombre`, `categoria_descripcion`, `categoria_img`) VALUES
(41, 'Arte ', 'Disfruta de nuestras nuevas exposiciones.', '54477.png'),
(42, 'Ciencia', 'Descubre las nuevas ponencias y exposiciones.', '32082.png'),
(44, 'Cultura', 'Descubre los nuevos talleres y eventos disponibles que tenemos para la nueva temporada', '68558.png'),
(55, 'prueba', 'descripcion de categoria', '20078.png'),
(57, 'Categoría', 'Nuevos eventos disponibles', '54278.png'),
(52, 'General', 'Nuevas actividades de interes', '12569.jpeg');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `evento`
--

CREATE TABLE `evento` (
  `evento_id` int(5) NOT NULL,
  `categoria_id` int(5) NOT NULL,
  `evento_nombre` varchar(50) CHARACTER SET utf8 NOT NULL,
  `evento_descripcion` varchar(200) CHARACTER SET utf8 NOT NULL,
  `evento_img` varchar(20) CHARACTER SET utf8 NOT NULL,
  `evento_ubicacion` varchar(100) CHARACTER SET utf8 DEFAULT NULL,
  `evento_fecha_inicio` date NOT NULL,
  `evento_fecha_final` date NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `evento`
--

INSERT INTO `evento` (`evento_id`, `categoria_id`, `evento_nombre`, `evento_descripcion`, `evento_img`, `evento_ubicacion`, `evento_fecha_inicio`, `evento_fecha_final`) VALUES
(34295, 41, 'Taller de pintura', 'Nuevo taller de pintura al óleo impartido por el profe Jun M.Camarena inscripciones abiertas.', '34295.png', 'Extensión universitaria', '2018-05-31', '2018-06-21'),
(99825, 41, 'Arquitectura moderna', 'El Dr. Juan Zapato dará una ponencia sobre el peligro de construir en un lugares peligrosos', '99825.png', 'Auditorio Jaime Keller Torres', '2018-05-29', '2018-06-30'),
(95312, 41, 'Escultura', 'Los nuevos talleres de escultura en metal podrás crear figuras creativas y divertidas. ', '95312.png', 'Extensión universitaria', '2018-08-15', '2018-11-13'),
(33723, 41, 'Música', 'Desarolla tus habilidades con la guitarra y otros instrumentos musicales con el profeso Juan Pérez cerca de la extensión ', '33723.png', 'Extensión universitaria', '2018-08-08', '2018-09-06'),
(8218, 41, 'Literatura', 'Disfruta de la lectura Besos de papel del autor F.F Donald narrada por el cineasta Juan Ramon Montz', '08218.png', 'Extensión universitaria', '2018-11-14', '2018-11-14'),
(83614, 41, 'Danza de los condenados', 'Disfruta del ballet del croata James Puckle su nuevo performace en la extensión única presentación.', '83614.png', 'Auditorio Jaime Keller Torrres', '2018-09-04', '2018-09-04'),
(59334, 41, 'Cine de terror', 'La nueva cinta Terror y obscuridad será proyecta en a las 12:00 a.m en la extensión.', '59334.png', 'Extensión universitaria', '2018-11-21', '2018-11-21'),
(2892, 42, 'Conferencia de lógica', 'El profesor C Gutierres dará una conferencia de sobre la importancia de las metricas en el diseño de sistemas lógicos', '02892.png', 'Auditorio Jaime Keller Torres', '2018-11-21', '2018-11-21'),
(23700, 53, 'aas', 'asasa', '23700.png', 'Biblioteca', '2018-01-01', '2018-01-01');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `evento_avisos`
--

CREATE TABLE `evento_avisos` (
  `evento_id` int(5) NOT NULL,
  `evento_aviso` varchar(200) COLLATE utf8_spanish2_ci NOT NULL,
  `evento_time` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `evento_avisos`
--

INSERT INTO `evento_avisos` (`evento_id`, `evento_aviso`, `evento_time`) VALUES
(34295, 'Prueba de aviso', '2018-04-28 21:43:34'),
(99825, 'Prueba de aviso', '2018-04-12 12:35:50'),
(95312, 'Prueba de mensaje', '2018-04-29 00:15:42'),
(33723, 'asas', '2018-04-12 13:16:08'),
(8218, 'Prueba de aviso', '2018-04-12 11:42:30'),
(83614, 'Prueba de aviso', '2018-04-12 11:42:27');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `usuario`
--

CREATE TABLE `usuario` (
  `usuario_id` int(50) NOT NULL,
  `usuario_correo` varchar(100) COLLATE utf8_spanish2_ci NOT NULL,
  `usuario_pass` varchar(100) COLLATE utf8_spanish2_ci NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `usuario`
--

INSERT INTO `usuario` (`usuario_id`, `usuario_correo`, `usuario_pass`) VALUES
(9, 'correo@correo.com', '$2y$10$0VCLyA0MlkjOPjPCf7cjOOxpIDgxv1.nAJwqNQFgnzLHR1.kF4l5C'),
(2, 'arock_arock@hotmail.com', '$2y$10$7VyWgjEQkh93Mea4hDkgt.Axnz3WZ7lT2mNTD2hfsLpWNUnEjyhWW'),
(3, 'correo@gmail.com', '$2y$10$gBnr12DdiLZNy0ZxwTcmD.WsbcYR.GENb1d/YxP9P.VkubHREEipi'),
(4, 'ness.reaper@gmail.com', '$2y$10$MLr2Xs/tj4zHua3MLBZ0e.qsfsvZgIugaUwkxNd2HqBEGrrX.tlMW'),
(5, 'teresa_gocha@hotmail.com', '$2y$10$4StpCw7ZX6r2lz7wJNhmROYAN4YAtpN1lTFR3mWUbHm5oG4rrN8pi'),
(6, 'uroboros_reaper@hotmail.com', '$2y$10$vueWtUvwfB8k3ipAE8E19OxInESFxZxPnkREgI.jDMz/OzovdavOS'),
(7, 'cesar_a.h@outlook.es', '$2y$10$7gfS9Lhfm4bIFA1W0SWgouSmHGY/0dutxvLppOhjH8ILaaIv6ToaO'),
(8, 'carpin135@gmail.com', '$2y$10$6a0T6rfN1ydQ.MFvjLXU1.q4MHv6YLjS.48bM1AHb4Zk61NXd.NNm');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `usuario_admin`
--

CREATE TABLE `usuario_admin` (
  `usuario_email` varchar(50) CHARACTER SET utf8 NOT NULL,
  `usuario_password` varchar(255) CHARACTER SET utf8 NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `usuario_admin`
--

INSERT INTO `usuario_admin` (`usuario_email`, `usuario_password`) VALUES
('correo@correo.com', '$2y$10$H35NISmVrimjRgopw/RDR.FYS0YEmWha2nPyv4hJ2YQ/yUCuOCppm');

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `usuario_perfil`
--

CREATE TABLE `usuario_perfil` (
  `usuario_nombre` varchar(50) COLLATE utf8_spanish2_ci DEFAULT NULL,
  `usuario_apellido` varchar(50) COLLATE utf8_spanish2_ci DEFAULT NULL,
  `usuario_registro` datetime NOT NULL,
  `usuario_ultimo_inicio` datetime NOT NULL,
  `usuario_id` int(50) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_spanish2_ci;

--
-- Volcado de datos para la tabla `usuario_perfil`
--

INSERT INTO `usuario_perfil` (`usuario_nombre`, `usuario_apellido`, `usuario_registro`, `usuario_ultimo_inicio`, `usuario_id`) VALUES
('', '', '2018-04-04 20:09:57', '2018-03-29 00:38:24', 1),
('Mateo', 'Fermín', '2018-04-04 20:50:04', '2018-03-31 12:21:30', 2),
('Jhon', 'McMan', '2018-04-04 20:28:30', '2018-04-04 15:41:45', 3),
('Jesus', 'Chavez', '2018-03-05 00:00:00', '2018-04-04 22:29:44', 4),
('Teresa', 'González', '1989-04-04 00:00:00', '2018-04-05 00:08:55', 5),
('Juan', 'chaval', '1989-11-15 00:00:00', '2018-04-10 23:34:55', 6),
('Tacet', 'Hernández', '2000-03-02 00:00:00', '2018-04-15 20:01:47', 7),
('carlos', 'pineda', '1957-04-04 00:00:00', '2018-04-17 15:54:15', 8),
('Usuario nombre', 'Usuaro apellido', '2015-04-29 00:00:00', '2018-04-29 23:55:13', 9);

--
-- Índices para tablas volcadas
--

--
-- Indices de la tabla `categoria_evento`
--
ALTER TABLE `categoria_evento`
  ADD PRIMARY KEY (`categoria_id`);

--
-- Indices de la tabla `evento`
--
ALTER TABLE `evento`
  ADD UNIQUE KEY `evento_id` (`evento_id`);

--
-- Indices de la tabla `evento_avisos`
--
ALTER TABLE `evento_avisos`
  ADD PRIMARY KEY (`evento_id`);

--
-- Indices de la tabla `usuario`
--
ALTER TABLE `usuario`
  ADD PRIMARY KEY (`usuario_id`);

--
-- Indices de la tabla `usuario_admin`
--
ALTER TABLE `usuario_admin`
  ADD PRIMARY KEY (`usuario_email`);

--
-- Indices de la tabla `usuario_perfil`
--
ALTER TABLE `usuario_perfil`
  ADD PRIMARY KEY (`usuario_id`);

--
-- AUTO_INCREMENT de las tablas volcadas
--

--
-- AUTO_INCREMENT de la tabla `categoria_evento`
--
ALTER TABLE `categoria_evento`
  MODIFY `categoria_id` int(5) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=58;

--
-- AUTO_INCREMENT de la tabla `usuario`
--
ALTER TABLE `usuario`
  MODIFY `usuario_id` int(50) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;

--
-- AUTO_INCREMENT de la tabla `usuario_perfil`
--
ALTER TABLE `usuario_perfil`
  MODIFY `usuario_id` int(50) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=10;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
